---
- name: Playbook to stage/tftp .bin to router bootflash
  hosts: Router_Group
  gather_facts: False
  vars:
   tftp: 209.22.126.12
   new_version: 17.09.03a
   new_image_ios: "isr4400-universalk9.{{ new_version }}.SPA.bin" 
   md5_hash: fb48d82b6f9ac0f05b00d3cc187e29b6


  tasks:

  - name: Ensure TFTP blocksize
    cisco.ios.ios_config:
      lines: ip tftp blocksize 8192

  - name: check if image already exist in bootflash
    cisco.ios.ios_command:
      commands: 'dir bootflash: | include {{ new_image_ios }}'
    register: check_image

  - name: fetch new image from tftp to bootflash
    vars:
      ansible_command_timeout: 3200
      number_of_retries: 5
    cisco.ios.ios_command:
      commands:
      - command: 'copy tftp://{{ tftp }}/{{ new_image_ios }} bootflash:{{ new_image_ios }}'   
        prompt: 'Destination filename \[{{ new_image_ios }}\]'
        answer: "\r"
      interval: 10
      retries: "{{ number_of_retries | int }}"
      wait_for: result[0] contains OK
    when: check_image.stdout[0].find( new_image_ios )  == -1
      
  - name: Verify MD5 Hash of Image File
    vars:
      ansible_command_timeout: 1200
    cisco.ios.ios_command:
      commands: 'verify /md5 bootflash:/{{ new_image_ios }} {{ md5_hash }}'
    register: md5_hash_verification_results
  
  - name: Set md5_hash_verification to pass/fail
    ansible.builtin.set_fact:
      md5_hash_verification: "pass"
    when: md5_hash_verification_results.stdout[0].find('Verified') != -1
      
  - name: Fail Task if MD5 Hash Check Fails
    ansible.builtin.fail:
      msg: "MD5 Hash Check Fails. Please check the uploaded image!"
    when: md5_hash_verification_results.stdout[0].find('Verified') == -1

